package org.rhq.enterprise.server.plugins.alertXymon;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

/**
 * Created by IntelliJ IDEA.
 * User: torben
 * Date: 12/10/10
 * Time: 5:14 PM
 * To change this template use File | Settings | File Templates.
 */
public class XymonInfoTest {
    XymonInfo info;
    XymonInfo missingBin;
    XymonInfo missingHost;
    XymonInfo missingReq;
    XymonInfo emptyPrefix;
    XymonInfo nullPrefix;

    @Before
    public void setUp() throws Exception {
        info = new XymonInfo("/usr/local/bin/bb", "myHost", "jboss", true);
        missingBin = new XymonInfo(null, "myHost", "jboss", true);
        missingHost = new XymonInfo("bb", null, "jboss", true);
        missingReq = new XymonInfo(null, null, "jboss", true);
        emptyPrefix = new XymonInfo(null, null, "", true);
        nullPrefix = new XymonInfo(null, null, "", true);
    }

    @Test
    public void testErrors() {
        assertEquals("getErrors() does not return null.", null, info.getErrors());
        assertEquals("getErrors() does not return the correct error msg.", "Missing: Binary", missingBin.getErrors());
        assertEquals("getErrors() does not return the correct error msg.", "Missing: Host", missingHost.getErrors());
        assertEquals("getErrors() does not return the correct error msg.", "Missing: Binary, Host", missingReq.getErrors());
    }

    @Test
    public void testMerge() {
        assertEquals("wrong merge!", info, XymonInfo.merge(
                info,
                new XymonInfo(null, "", null, true)));
        assertEquals("wrong merge!", new XymonInfo("/usr/local/bin/bb", "myHost", "jboss", false), XymonInfo.merge(
                info,
                new XymonInfo(null, null, null, false)));
        assertEquals("wrong merge!", new XymonInfo("foo", "bar", "foobar", false), XymonInfo.merge(
                info,
                new XymonInfo("foo", "bar", "foobar", false)));
        // todo: test group flag override with single alert
    }

    @Test
    public void testPrefix() {
        assertEquals("wrong null prefix!", "", emptyPrefix.getPrefix() );
        assertEquals("wrong empty prefix!", "", nullPrefix.getPrefix());
        assertNotNull("return value is null!", nullPrefix.getPrefix());
        assertEquals("wrong provided prefix!", "jboss-", info.getPrefix());
    }
}
